<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: PregelCommunicator&lt; DATA_CONTAINER_TYPE &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classPregelCommunicator-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">PregelCommunicator&lt; DATA_CONTAINER_TYPE &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__comm__engine.html">Communication Engine</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>core communicator class definition It handles all the MPI communication between devices (including both system and data messages) The current version works in a blocking mode where we have explicit functions to receive/transmit all messages It is a template class that is parameterized by  
 <a href="classPregelCommunicator.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglCommunicationPregelCommunicator_8hpp_source.html">tiglCommunicationPregelCommunicator.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ac9fa67b645c820c2f37cea3dcd36fbd7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac9fa67b645c820c2f37cea3dcd36fbd7"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#ac9fa67b645c820c2f37cea3dcd36fbd7">PregelCommunicator</a> (DATA_CONTAINER_TYPE *<a class="el" href="classPregelCommunicator.html#ad0836c0a6713b5084626c053b2609721">dataPtr</a>, uint32 devices, int <a class="el" href="classPregelCommunicator.html#a886da2e5d226022133297f6461033f2a">rank</a>=0)</td></tr>
<tr class="memdesc:ac9fa67b645c820c2f37cea3dcd36fbd7"><td class="mdescLeft">&#160;</td><td class="mdescRight">@ brief constructor that has the data pointer and <br /></td></tr>
<tr class="separator:ac9fa67b645c820c2f37cea3dcd36fbd7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac0c5a6de5c5f1802a46962a2ea7294fc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac0c5a6de5c5f1802a46962a2ea7294fc"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#ac0c5a6de5c5f1802a46962a2ea7294fc">reset</a> ()</td></tr>
<tr class="memdesc:ac0c5a6de5c5f1802a46962a2ea7294fc"><td class="mdescLeft">&#160;</td><td class="mdescRight">reset procedure <br /></td></tr>
<tr class="separator:ac0c5a6de5c5f1802a46962a2ea7294fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c1fec23444ddd131dd6eac0626ada3b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a0c1fec23444ddd131dd6eac0626ada3b">init</a> (DATA_CONTAINER_TYPE *dPtr, uint32 devices=1, uint32 devRank=0)</td></tr>
<tr class="memdesc:a0c1fec23444ddd131dd6eac0626ada3b"><td class="mdescLeft">&#160;</td><td class="mdescRight">initializes the communicator object  <a href="#a0c1fec23444ddd131dd6eac0626ada3b">More...</a><br /></td></tr>
<tr class="separator:a0c1fec23444ddd131dd6eac0626ada3b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b8291a5b8a01bed346f27d6eb2b519e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0b8291a5b8a01bed346f27d6eb2b519e"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a0b8291a5b8a01bed346f27d6eb2b519e">setNumVertices</a> (uint64 numVertices)</td></tr>
<tr class="memdesc:a0b8291a5b8a01bed346f27d6eb2b519e"><td class="mdescLeft">&#160;</td><td class="mdescRight">passes the total number of vertices in the graph (used in finding the device for each vertex) <br /></td></tr>
<tr class="separator:a0b8291a5b8a01bed346f27d6eb2b519e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aac3d9db0bfd173f6c9d24d06d8ff0a56"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aac3d9db0bfd173f6c9d24d06d8ff0a56"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#aac3d9db0bfd173f6c9d24d06d8ff0a56">isMultipleDevices</a> ()</td></tr>
<tr class="memdesc:aac3d9db0bfd173f6c9d24d06d8ff0a56"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns true if multiple devices are used, otherwise returns false <br /></td></tr>
<tr class="separator:aac3d9db0bfd173f6c9d24d06d8ff0a56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acf608880f1a6eec80af5fe638422d94b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#acf608880f1a6eec80af5fe638422d94b">sendAllMessages</a> (map&lt; ID_TYPE, MESSAGE_BUF_TYPE &gt; *messagePtr)</td></tr>
<tr class="memdesc:acf608880f1a6eec80af5fe638422d94b"><td class="mdescLeft">&#160;</td><td class="mdescRight">sending all system and data messages. This is a blocking function  <a href="#acf608880f1a6eec80af5fe638422d94b">More...</a><br /></td></tr>
<tr class="separator:acf608880f1a6eec80af5fe638422d94b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e99d93e817dc4cc4a7d97d34a941d41"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8e99d93e817dc4cc4a7d97d34a941d41"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a8e99d93e817dc4cc4a7d97d34a941d41">sendSysMessages</a> ()</td></tr>
<tr class="memdesc:a8e99d93e817dc4cc4a7d97d34a941d41"><td class="mdescLeft">&#160;</td><td class="mdescRight">sending all system messages. This is a blocking function <br /></td></tr>
<tr class="separator:a8e99d93e817dc4cc4a7d97d34a941d41"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b2ec835552c9c7c11914f42f928af0b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a0b2ec835552c9c7c11914f42f928af0b">sendDataMessages</a> (map&lt; ID_TYPE, MESSAGE_BUF_TYPE &gt; *messagePtr)</td></tr>
<tr class="memdesc:a0b2ec835552c9c7c11914f42f928af0b"><td class="mdescLeft">&#160;</td><td class="mdescRight">core function for sending all MPI data messages  <a href="#a0b2ec835552c9c7c11914f42f928af0b">More...</a><br /></td></tr>
<tr class="separator:a0b2ec835552c9c7c11914f42f928af0b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa93cebf937b0f2bea1873a6aa9f9f132"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#aa93cebf937b0f2bea1873a6aa9f9f132">TIGLCommunicationSendMPICommand</a> (byte *txBuf, uint32 bufSize, int32 dst)</td></tr>
<tr class="memdesc:aa93cebf937b0f2bea1873a6aa9f9f132"><td class="mdescLeft">&#160;</td><td class="mdescRight">overloaded: sending a single message to a particular destination  <a href="#aa93cebf937b0f2bea1873a6aa9f9f132">More...</a><br /></td></tr>
<tr class="separator:aa93cebf937b0f2bea1873a6aa9f9f132"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a87e606cfb6aa33ece2ab1ac00d41be24"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a87e606cfb6aa33ece2ab1ac00d41be24">TIGLCommunicationSendMPICommand</a> (byte *txBuf, uint32 bufSize, int32 dst, int tag)</td></tr>
<tr class="memdesc:a87e606cfb6aa33ece2ab1ac00d41be24"><td class="mdescLeft">&#160;</td><td class="mdescRight">overloaded: sending a single message to a particular destination with a given tag  <a href="#a87e606cfb6aa33ece2ab1ac00d41be24">More...</a><br /></td></tr>
<tr class="separator:a87e606cfb6aa33ece2ab1ac00d41be24"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65d86ed247f64d459e354692048afaa0"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a65d86ed247f64d459e354692048afaa0">instRecvMessages</a> ()</td></tr>
<tr class="memdesc:a65d86ed247f64d459e354692048afaa0"><td class="mdescLeft">&#160;</td><td class="mdescRight">core function for receiving all MPI messages (This is a blocking function) It checks for input MPI messages and routes each data/system message to the proper message buffer  <a href="#a65d86ed247f64d459e354692048afaa0">More...</a><br /></td></tr>
<tr class="separator:a65d86ed247f64d459e354692048afaa0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee3cb003701ef5b21185d3669934f277"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#aee3cb003701ef5b21185d3669934f277">TIGLCommunicationRecvMPICommand</a> (byte *rxBuf, uint32 bufSize, int32 src)</td></tr>
<tr class="memdesc:aee3cb003701ef5b21185d3669934f277"><td class="mdescLeft">&#160;</td><td class="mdescRight">receiving a message from a particular src with any tag  <a href="#aee3cb003701ef5b21185d3669934f277">More...</a><br /></td></tr>
<tr class="separator:aee3cb003701ef5b21185d3669934f277"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab775dfabdb5064db6afa65091a538228"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#ab775dfabdb5064db6afa65091a538228">TIGLCommunicationRecvMPICommand</a> (byte *rxBuf, uint32 bufSize, int32 src, int tag)</td></tr>
<tr class="memdesc:ab775dfabdb5064db6afa65091a538228"><td class="mdescLeft">&#160;</td><td class="mdescRight">receiving a message from a particular src with a given tag  <a href="#ab775dfabdb5064db6afa65091a538228">More...</a><br /></td></tr>
<tr class="separator:ab775dfabdb5064db6afa65091a538228"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acea08876e4c156436aaf1ba631c74e24"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#acea08876e4c156436aaf1ba631c74e24">TIGLCommunicationRecvMPICommand</a> (byte *rxBuf, int32 *numMessageBytes)</td></tr>
<tr class="memdesc:acea08876e4c156436aaf1ba631c74e24"><td class="mdescLeft">&#160;</td><td class="mdescRight">receiving a message with any tag from any source  <a href="#acea08876e4c156436aaf1ba631c74e24">More...</a><br /></td></tr>
<tr class="separator:acea08876e4c156436aaf1ba631c74e24"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adb7a1e64e6f0734f338b8452c964c54c"><td class="memItemLeft" align="right" valign="top">uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#adb7a1e64e6f0734f338b8452c964c54c">TIGLCommunicationFindDevice</a> (uint32 vtxID)</td></tr>
<tr class="memdesc:adb7a1e64e6f0734f338b8452c964c54c"><td class="mdescLeft">&#160;</td><td class="mdescRight">finds the device of a given vertex  <a href="#adb7a1e64e6f0734f338b8452c964c54c">More...</a><br /></td></tr>
<tr class="separator:adb7a1e64e6f0734f338b8452c964c54c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af0ae3411941092ce8b8c450db50441b1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#af0ae3411941092ce8b8c450db50441b1">bytes2Messages</a> (byte *rxBuf, uint32 messageSize, MESSAGE_BUF_TYPE &amp;messageBuf)</td></tr>
<tr class="memdesc:af0ae3411941092ce8b8c450db50441b1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a sequence of bytes to messages (can be one or more than one messages)  <a href="#af0ae3411941092ce8b8c450db50441b1">More...</a><br /></td></tr>
<tr class="separator:af0ae3411941092ce8b8c450db50441b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ed0400c51a92b59ffa301963d29d28e"><td class="memItemLeft" align="right" valign="top">uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a4ed0400c51a92b59ffa301963d29d28e">messages2Bytes</a> (MESSAGE_BUF_TYPE *messagePtr, byte *outBuf)</td></tr>
<tr class="memdesc:a4ed0400c51a92b59ffa301963d29d28e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a group of data messages to a sequence of bytes to be sent.  <a href="#a4ed0400c51a92b59ffa301963d29d28e">More...</a><br /></td></tr>
<tr class="separator:a4ed0400c51a92b59ffa301963d29d28e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ab6840262f880fffd8f6645fff27f7c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8ab6840262f880fffd8f6645fff27f7c"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a8ab6840262f880fffd8f6645fff27f7c">getRank</a> ()</td></tr>
<tr class="memdesc:a8ab6840262f880fffd8f6645fff27f7c"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the rank of the device <br /></td></tr>
<tr class="separator:a8ab6840262f880fffd8f6645fff27f7c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae5db25c2cbca8041db476be5c0c66b0"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#aae5db25c2cbca8041db476be5c0c66b0">TIGLCommunicationExistMessages</a> ()</td></tr>
<tr class="memdesc:aae5db25c2cbca8041db476be5c0c66b0"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if there exist messages from any source with any tag  <a href="#aae5db25c2cbca8041db476be5c0c66b0">More...</a><br /></td></tr>
<tr class="separator:aae5db25c2cbca8041db476be5c0c66b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5df944d875839d0008ea80dff2b19451"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a5df944d875839d0008ea80dff2b19451">TIGLCommunicationExistMessagesFromDev</a> (uint32 dev)</td></tr>
<tr class="memdesc:a5df944d875839d0008ea80dff2b19451"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if there exist messages with any tag from a given source device  <a href="#a5df944d875839d0008ea80dff2b19451">More...</a><br /></td></tr>
<tr class="separator:a5df944d875839d0008ea80dff2b19451"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a064c422d0aa2b1bc478cf420c4851656"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a064c422d0aa2b1bc478cf420c4851656">TIGLCommunicationExistMessagesWithTag</a> (int tag)</td></tr>
<tr class="memdesc:a064c422d0aa2b1bc478cf420c4851656"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if there exist messages with a given tag from any source  <a href="#a064c422d0aa2b1bc478cf420c4851656">More...</a><br /></td></tr>
<tr class="separator:a064c422d0aa2b1bc478cf420c4851656"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:ad0836c0a6713b5084626c053b2609721"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad0836c0a6713b5084626c053b2609721"></a>
DATA_CONTAINER_TYPE *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#ad0836c0a6713b5084626c053b2609721">dataPtr</a></td></tr>
<tr class="memdesc:ad0836c0a6713b5084626c053b2609721"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to <a class="el" href="classPregelDataContainer.html" title="Basic graph container for each Device in Pregel system. It inherits the subgraph class and adds the m...">PregelDataContainer</a> object that contains all message buffers <br /></td></tr>
<tr class="separator:ad0836c0a6713b5084626c053b2609721"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1d2f789f3c492ab86520f2f9f05e4f7d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1d2f789f3c492ab86520f2f9f05e4f7d"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a1d2f789f3c492ab86520f2f9f05e4f7d">numDevices</a></td></tr>
<tr class="memdesc:a1d2f789f3c492ab86520f2f9f05e4f7d"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of devices <br /></td></tr>
<tr class="separator:a1d2f789f3c492ab86520f2f9f05e4f7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9342c483ed8bc1478e5991cac92304a0"><td class="memItemLeft" align="right" valign="top">uint64&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a9342c483ed8bc1478e5991cac92304a0">totalNumVertices</a></td></tr>
<tr class="separator:a9342c483ed8bc1478e5991cac92304a0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad2369b8d191a328714ce2c0c9372e1b6"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad2369b8d191a328714ce2c0c9372e1b6"></a>
uint32 *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#ad2369b8d191a328714ce2c0c9372e1b6">timeCountSS</a></td></tr>
<tr class="memdesc:ad2369b8d191a328714ce2c0c9372e1b6"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to the ss counter <br /></td></tr>
<tr class="separator:ad2369b8d191a328714ce2c0c9372e1b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a886da2e5d226022133297f6461033f2a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a886da2e5d226022133297f6461033f2a"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCommunicator.html#a886da2e5d226022133297f6461033f2a">rank</a></td></tr>
<tr class="memdesc:a886da2e5d226022133297f6461033f2a"><td class="mdescLeft">&#160;</td><td class="mdescRight">MPI rank of the current device. <br /></td></tr>
<tr class="separator:a886da2e5d226022133297f6461033f2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename DATA_CONTAINER_TYPE&gt;<br />
class PregelCommunicator&lt; DATA_CONTAINER_TYPE &gt;</h3>

<p>core communicator class definition It handles all the MPI communication between devices (including both system and data messages) The current version works in a blocking mode where we have explicit functions to receive/transmit all messages It is a template class that is parameterized by </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">DATA_CONTAINER_TYPE</td><td>the class definition of the data manager object </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="af0ae3411941092ce8b8c450db50441b1"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::bytes2Messages </td>
          <td>(</td>
          <td class="paramtype">byte *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>messageSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_BUF_TYPE &amp;&#160;</td>
          <td class="paramname"><em>messageBuf</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Convert a sequence of bytes to messages (can be one or more than one messages) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>pointer to bytes to be converted </td></tr>
    <tr><td class="paramname">messageSize</td><td>number of bytes to convert </td></tr>
    <tr><td class="paramname">messageBuf</td><td>message buffer to stored converted messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aae5db25c2cbca8041db476be5c0c66b0"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::TIGLCommunicationExistMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>check if there exist messages from any source with any tag </p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">true</td><td>if there are messages, false otherwise </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5df944d875839d0008ea80dff2b19451"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::TIGLCommunicationExistMessagesFromDev </td>
          <td>(</td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>dev</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>check if there exist messages with any tag from a given source device </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">&lt;dev&gt;</td><td>source device </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">true</td><td>if there are messages, false otherwise </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a064c422d0aa2b1bc478cf420c4851656"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::TIGLCommunicationExistMessagesWithTag </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>check if there exist messages with a given tag from any source </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">&lt;tag&gt;</td><td>message tag </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">true</td><td>if there are messages, false otherwise </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="adb7a1e64e6f0734f338b8452c964c54c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint32 <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::TIGLCommunicationFindDevice </td>
          <td>(</td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>vtxID</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>finds the device of a given vertex </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vtxID</td><td>ID of vertex of interest </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">device</td><td>id of device that owns 'vtxID' </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0c1fec23444ddd131dd6eac0626ada3b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::init </td>
          <td>(</td>
          <td class="paramtype">DATA_CONTAINER_TYPE *&#160;</td>
          <td class="paramname"><em>dPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>devices</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>devRank</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>initializes the communicator object </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dPtr</td><td>pointer to the data container object </td></tr>
    <tr><td class="paramname">devices</td><td>total number of devices </td></tr>
    <tr><td class="paramname">devRank</td><td>rank of the current device </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a65d86ed247f64d459e354692048afaa0"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::instRecvMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>core function for receiving all MPI messages (This is a blocking function) It checks for input MPI messages and routes each data/system message to the proper message buffer </p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">true</td><td>if there exists messages, false otherwise </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4ed0400c51a92b59ffa301963d29d28e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint32 <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::messages2Bytes </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_BUF_TYPE *&#160;</td>
          <td class="paramname"><em>messagePtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">byte *&#160;</td>
          <td class="paramname"><em>outBuf</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Convert a group of data messages to a sequence of bytes to be sent. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">messagePtr</td><td>pointer to message buffer </td></tr>
    <tr><td class="paramname">outBuf</td><td>pointer to allocated byte buffer </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>number of bytes consumed </dd></dl>

</div>
</div>
<a class="anchor" id="aee3cb003701ef5b21185d3669934f277"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::TIGLCommunicationRecvMPICommand </td>
          <td>(</td>
          <td class="paramtype">byte *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>bufSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32&#160;</td>
          <td class="paramname"><em>src</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>receiving a message from a particular src with any tag </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>receiver buffer </td></tr>
    <tr><td class="paramname">bufSize</td><td>buffer size in bytes </td></tr>
    <tr><td class="paramname">src</td><td>the message source device </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>size of the message in bytes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab775dfabdb5064db6afa65091a538228"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::TIGLCommunicationRecvMPICommand </td>
          <td>(</td>
          <td class="paramtype">byte *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>bufSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>receiving a message from a particular src with a given tag </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>receiver buffer </td></tr>
    <tr><td class="paramname">bufSize</td><td>buffer size in bytes </td></tr>
    <tr><td class="paramname">src</td><td>the message source device </td></tr>
    <tr><td class="paramname">tag</td><td>the message tag </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>size of the message in bytes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="acea08876e4c156436aaf1ba631c74e24"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::TIGLCommunicationRecvMPICommand </td>
          <td>(</td>
          <td class="paramtype">byte *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32 *&#160;</td>
          <td class="paramname"><em>numMessageBytes</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>receiving a message with any tag from any source </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>receiver buffer </td></tr>
    <tr><td class="paramname">numMessageBytes</td><td>pointer in which the message size is written </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>message tag </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="acf608880f1a6eec80af5fe638422d94b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::sendAllMessages </td>
          <td>(</td>
          <td class="paramtype">map&lt; ID_TYPE, MESSAGE_BUF_TYPE &gt; *&#160;</td>
          <td class="paramname"><em>messagePtr</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>sending all system and data messages. This is a blocking function </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">messagePtr</td><td>pointer to the data message buffer </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0b2ec835552c9c7c11914f42f928af0b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::sendDataMessages </td>
          <td>(</td>
          <td class="paramtype">map&lt; ID_TYPE, MESSAGE_BUF_TYPE &gt; *&#160;</td>
          <td class="paramname"><em>messagePtr</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>core function for sending all MPI data messages </p>
<p>From the receiver vertex index it determines the target device, then it accumulates few messages going to a certain device in a big buffer before sending using MPI interface. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">messagePtr</td><td>pointer to map&lt;id, messageBuffer&gt; that has a message buffer for each destination vertex </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa93cebf937b0f2bea1873a6aa9f9f132"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::TIGLCommunicationSendMPICommand </td>
          <td>(</td>
          <td class="paramtype">byte *&#160;</td>
          <td class="paramname"><em>txBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>bufSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32&#160;</td>
          <td class="paramname"><em>dst</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>overloaded: sending a single message to a particular destination </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">txBuf</td><td>tx buffer </td></tr>
    <tr><td class="paramname">bufSize</td><td>buffer size </td></tr>
    <tr><td class="paramname">dst</td><td>destination device </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a87e606cfb6aa33ece2ab1ac00d41be24"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::TIGLCommunicationSendMPICommand </td>
          <td>(</td>
          <td class="paramtype">byte *&#160;</td>
          <td class="paramname"><em>txBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>bufSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>overloaded: sending a single message to a particular destination with a given tag </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">txBuf</td><td>tx buffer </td></tr>
    <tr><td class="paramname">bufSize</td><td>buffer size </td></tr>
    <tr><td class="paramname">dst</td><td>destination device </td></tr>
    <tr><td class="paramname">tag</td><td>message tag </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="a9342c483ed8bc1478e5991cac92304a0"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint64 <a class="el" href="classPregelCommunicator.html">PregelCommunicator</a>&lt; DATA_CONTAINER_TYPE &gt;::totalNumVertices</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>total number of vertices in all devices in the current version it is used to find the device that corresponds to each vertex </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/standard/communication/<a class="el" href="tiglCommunicationPregelCommunicator_8hpp_source.html">tiglCommunicationPregelCommunicator.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 14 2014 14:29:26 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
